"use strict";
/**
 * MockServer API
 * Simple and fast mock server implemented in python
 *
 * The version of the OpenAPI document: 2.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetaApi = exports.MetaApiApiKeys = void 0;
const localVarRequest = require("request");
/* tslint:disable:no-unused-locals */
const models_1 = require("../model/models");
const apis_1 = require("./apis");
let defaultBasePath = "http://localhost";
// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================
var MetaApiApiKeys;
(function (MetaApiApiKeys) {})(
  (MetaApiApiKeys = exports.MetaApiApiKeys || (exports.MetaApiApiKeys = {}))
);
class MetaApi {
  constructor(basePathOrUsername, password, basePath) {
    this._basePath = defaultBasePath;
    this._defaultHeaders = {};
    this._useQuerystring = false;
    this.authentications = {
      default: new models_1.VoidAuth(),
    };
    this.interceptors = [];
    if (password) {
      if (basePath) {
        this.basePath = basePath;
      }
    } else {
      if (basePathOrUsername) {
        this.basePath = basePathOrUsername;
      }
    }
  }
  set useQuerystring(value) {
    this._useQuerystring = value;
  }
  set basePath(basePath) {
    this._basePath = basePath;
  }
  set defaultHeaders(defaultHeaders) {
    this._defaultHeaders = defaultHeaders;
  }
  get defaultHeaders() {
    return this._defaultHeaders;
  }
  get basePath() {
    return this._basePath;
  }
  setDefaultAuthentication(auth) {
    this.authentications.default = auth;
  }
  setApiKey(key, value) {
    this.authentications[MetaApiApiKeys[key]].apiKey = value;
  }
  addInterceptor(interceptor) {
    this.interceptors.push(interceptor);
  }
  /**
   * Status response for readiness and liveness probe
   * @summary Health Check
   */
  async healthCheck(options = { headers: {} }) {
    const localVarPath = this.basePath + "/_meta/health";
    let localVarQueryParameters = {};
    let localVarHeaderParams = Object.assign({}, this._defaultHeaders);
    const produces = ["application/json"];
    // give precedence to 'application/json'
    if (produces.indexOf("application/json") >= 0) {
      localVarHeaderParams.Accept = "application/json";
    } else {
      localVarHeaderParams.Accept = produces.join(",");
    }
    let localVarFormParams = {};
    Object.assign(localVarHeaderParams, options.headers);
    let localVarUseFormData = false;
    let localVarRequestOptions = {
      method: "GET",
      qs: localVarQueryParameters,
      headers: localVarHeaderParams,
      uri: localVarPath,
      useQuerystring: this._useQuerystring,
      json: true,
    };
    let authenticationPromise = Promise.resolve();
    authenticationPromise = authenticationPromise.then(() =>
      this.authentications.default.applyToRequest(localVarRequestOptions)
    );
    let interceptorPromise = authenticationPromise;
    for (const interceptor of this.interceptors) {
      interceptorPromise = interceptorPromise.then(() =>
        interceptor(localVarRequestOptions)
      );
    }
    return interceptorPromise.then(() => {
      if (Object.keys(localVarFormParams).length) {
        if (localVarUseFormData) {
          localVarRequestOptions.formData = localVarFormParams;
        } else {
          localVarRequestOptions.form = localVarFormParams;
        }
      }
      return new Promise((resolve, reject) => {
        localVarRequest(localVarRequestOptions, (error, response, body) => {
          if (error) {
            reject(error);
          } else {
            body = models_1.ObjectSerializer.deserialize(body, "object");
            if (
              response.statusCode &&
              response.statusCode >= 200 &&
              response.statusCode <= 299
            ) {
              resolve({ response: response, body: body });
            } else {
              reject(new apis_1.HttpError(response, body, response.statusCode));
            }
          }
        });
      });
    });
  }
}
exports.MetaApi = MetaApi;
//# sourceMappingURL=metaApi.js.map
