/**
 * MockServer API
 * Simple and fast mock server implemented in python
 *
 * The version of the OpenAPI document: 2.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/// <reference types="node" />
import http = require('http');
import { CreatePayload } from '../model/createPayload';
import { HttpRequest } from '../model/httpRequest';
import { Authentication, Interceptor } from '../model/models';
export declare enum MockServerApiApiKeys {
}
export declare class MockServerApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: MockServerApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    /**
     * Create route mock  If route is already mocked it will add it to queue.
     * @summary Add Mock
     * @param createPayload
     */
    addMock(createPayload: CreatePayload, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: object;
    }>;
    /**
     * Delete all mocked routes
     * @summary Clear All Mocks
     */
    clearAllMocks(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: object;
    }>;
    /**
     * Delete mock specified in request
     * @summary Delete Mock
     * @param httpRequest
     */
    deleteMock(httpRequest: HttpRequest, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: object;
    }>;
    /**
     * Get all mocked routes
     * @summary Get All Mocks
     */
    getAllMocks(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: object;
    }>;
}
