"use strict";
/**
 * MockServer API
 * Simple and fast mock server implemented in python
 *
 * The version of the OpenAPI document: 2.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MockServerApi = exports.MockServerApiApiKeys = void 0;
const localVarRequest = require("request");
const models_1 = require("../model/models");
const apis_1 = require("./apis");
let defaultBasePath = "http://localhost";
// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================
var MockServerApiApiKeys;
(function (MockServerApiApiKeys) {})(
  (MockServerApiApiKeys =
    exports.MockServerApiApiKeys || (exports.MockServerApiApiKeys = {}))
);
class MockServerApi {
  constructor(basePathOrUsername, password, basePath) {
    this._basePath = defaultBasePath;
    this._defaultHeaders = {};
    this._useQuerystring = false;
    this.authentications = {
      default: new models_1.VoidAuth(),
    };
    this.interceptors = [];
    if (password) {
      if (basePath) {
        this.basePath = basePath;
      }
    } else {
      if (basePathOrUsername) {
        this.basePath = basePathOrUsername;
      }
    }
  }
  set useQuerystring(value) {
    this._useQuerystring = value;
  }
  set basePath(basePath) {
    this._basePath = basePath;
  }
  set defaultHeaders(defaultHeaders) {
    this._defaultHeaders = defaultHeaders;
  }
  get defaultHeaders() {
    return this._defaultHeaders;
  }
  get basePath() {
    return this._basePath;
  }
  setDefaultAuthentication(auth) {
    this.authentications.default = auth;
  }
  setApiKey(key, value) {
    this.authentications[MockServerApiApiKeys[key]].apiKey = value;
  }
  addInterceptor(interceptor) {
    this.interceptors.push(interceptor);
  }
  /**
   * Create route mock  If route is already mocked it will add it to queue.
   * @summary Add Mock
   * @param createPayload
   */
  async addMock(createPayload, options = { headers: {} }) {
    const localVarPath = this.basePath + "/mockserver";
    let localVarQueryParameters = {};
    let localVarHeaderParams = Object.assign({}, this._defaultHeaders);
    const produces = ["application/json"];
    // give precedence to 'application/json'
    if (produces.indexOf("application/json") >= 0) {
      localVarHeaderParams.Accept = "application/json";
    } else {
      localVarHeaderParams.Accept = produces.join(",");
    }
    let localVarFormParams = {};
    // verify required parameter 'createPayload' is not null or undefined
    if (createPayload === null || createPayload === undefined) {
      throw new Error(
        "Required parameter createPayload was null or undefined when calling addMock."
      );
    }
    Object.assign(localVarHeaderParams, options.headers);
    let localVarUseFormData = false;
    let localVarRequestOptions = {
      method: "POST",
      qs: localVarQueryParameters,
      headers: localVarHeaderParams,
      uri: localVarPath,
      useQuerystring: this._useQuerystring,
      json: true,
      body: models_1.ObjectSerializer.serialize(createPayload, "CreatePayload"),
    };
    let authenticationPromise = Promise.resolve();
    authenticationPromise = authenticationPromise.then(() =>
      this.authentications.default.applyToRequest(localVarRequestOptions)
    );
    let interceptorPromise = authenticationPromise;
    for (const interceptor of this.interceptors) {
      interceptorPromise = interceptorPromise.then(() =>
        interceptor(localVarRequestOptions)
      );
    }
    return interceptorPromise.then(() => {
      if (Object.keys(localVarFormParams).length) {
        if (localVarUseFormData) {
          localVarRequestOptions.formData = localVarFormParams;
        } else {
          localVarRequestOptions.form = localVarFormParams;
        }
      }
      return new Promise((resolve, reject) => {
        localVarRequest(localVarRequestOptions, (error, response, body) => {
          if (error) {
            reject(error);
          } else {
            body = models_1.ObjectSerializer.deserialize(body, "object");
            if (
              response.statusCode &&
              response.statusCode >= 200 &&
              response.statusCode <= 299
            ) {
              resolve({ response: response, body: body });
            } else {
              reject(new apis_1.HttpError(response, body, response.statusCode));
            }
          }
        });
      });
    });
  }
  /**
   * Delete all mocked routes
   * @summary Clear All Mocks
   */
  async clearAllMocks(options = { headers: {} }) {
    const localVarPath = this.basePath + "/mockserver/reset";
    let localVarQueryParameters = {};
    let localVarHeaderParams = Object.assign({}, this._defaultHeaders);
    const produces = ["application/json"];
    // give precedence to 'application/json'
    if (produces.indexOf("application/json") >= 0) {
      localVarHeaderParams.Accept = "application/json";
    } else {
      localVarHeaderParams.Accept = produces.join(",");
    }
    let localVarFormParams = {};
    Object.assign(localVarHeaderParams, options.headers);
    let localVarUseFormData = false;
    let localVarRequestOptions = {
      method: "DELETE",
      qs: localVarQueryParameters,
      headers: localVarHeaderParams,
      uri: localVarPath,
      useQuerystring: this._useQuerystring,
      json: true,
    };
    let authenticationPromise = Promise.resolve();
    authenticationPromise = authenticationPromise.then(() =>
      this.authentications.default.applyToRequest(localVarRequestOptions)
    );
    let interceptorPromise = authenticationPromise;
    for (const interceptor of this.interceptors) {
      interceptorPromise = interceptorPromise.then(() =>
        interceptor(localVarRequestOptions)
      );
    }
    return interceptorPromise.then(() => {
      if (Object.keys(localVarFormParams).length) {
        if (localVarUseFormData) {
          localVarRequestOptions.formData = localVarFormParams;
        } else {
          localVarRequestOptions.form = localVarFormParams;
        }
      }
      return new Promise((resolve, reject) => {
        localVarRequest(localVarRequestOptions, (error, response, body) => {
          if (error) {
            reject(error);
          } else {
            body = models_1.ObjectSerializer.deserialize(body, "object");
            if (
              response.statusCode &&
              response.statusCode >= 200 &&
              response.statusCode <= 299
            ) {
              resolve({ response: response, body: body });
            } else {
              reject(new apis_1.HttpError(response, body, response.statusCode));
            }
          }
        });
      });
    });
  }
  /**
   * Delete mock specified in request
   * @summary Delete Mock
   * @param httpRequest
   */
  async deleteMock(httpRequest, options = { headers: {} }) {
    const localVarPath = this.basePath + "/mockserver";
    let localVarQueryParameters = {};
    let localVarHeaderParams = Object.assign({}, this._defaultHeaders);
    const produces = ["application/json"];
    // give precedence to 'application/json'
    if (produces.indexOf("application/json") >= 0) {
      localVarHeaderParams.Accept = "application/json";
    } else {
      localVarHeaderParams.Accept = produces.join(",");
    }
    let localVarFormParams = {};
    // verify required parameter 'httpRequest' is not null or undefined
    if (httpRequest === null || httpRequest === undefined) {
      throw new Error(
        "Required parameter httpRequest was null or undefined when calling deleteMock."
      );
    }
    Object.assign(localVarHeaderParams, options.headers);
    let localVarUseFormData = false;
    let localVarRequestOptions = {
      method: "DELETE",
      qs: localVarQueryParameters,
      headers: localVarHeaderParams,
      uri: localVarPath,
      useQuerystring: this._useQuerystring,
      json: true,
      body: models_1.ObjectSerializer.serialize(httpRequest, "HttpRequest"),
    };
    let authenticationPromise = Promise.resolve();
    authenticationPromise = authenticationPromise.then(() =>
      this.authentications.default.applyToRequest(localVarRequestOptions)
    );
    let interceptorPromise = authenticationPromise;
    for (const interceptor of this.interceptors) {
      interceptorPromise = interceptorPromise.then(() =>
        interceptor(localVarRequestOptions)
      );
    }
    return interceptorPromise.then(() => {
      if (Object.keys(localVarFormParams).length) {
        if (localVarUseFormData) {
          localVarRequestOptions.formData = localVarFormParams;
        } else {
          localVarRequestOptions.form = localVarFormParams;
        }
      }
      return new Promise((resolve, reject) => {
        localVarRequest(localVarRequestOptions, (error, response, body) => {
          if (error) {
            reject(error);
          } else {
            body = models_1.ObjectSerializer.deserialize(body, "object");
            if (
              response.statusCode &&
              response.statusCode >= 200 &&
              response.statusCode <= 299
            ) {
              resolve({ response: response, body: body });
            } else {
              reject(new apis_1.HttpError(response, body, response.statusCode));
            }
          }
        });
      });
    });
  }
  /**
   * Get all mocked routes
   * @summary Get All Mocks
   */
  async getAllMocks(options = { headers: {} }) {
    const localVarPath = this.basePath + "/mockserver";
    let localVarQueryParameters = {};
    let localVarHeaderParams = Object.assign({}, this._defaultHeaders);
    const produces = ["application/json"];
    // give precedence to 'application/json'
    if (produces.indexOf("application/json") >= 0) {
      localVarHeaderParams.Accept = "application/json";
    } else {
      localVarHeaderParams.Accept = produces.join(",");
    }
    let localVarFormParams = {};
    Object.assign(localVarHeaderParams, options.headers);
    let localVarUseFormData = false;
    let localVarRequestOptions = {
      method: "GET",
      qs: localVarQueryParameters,
      headers: localVarHeaderParams,
      uri: localVarPath,
      useQuerystring: this._useQuerystring,
      json: true,
    };
    let authenticationPromise = Promise.resolve();
    authenticationPromise = authenticationPromise.then(() =>
      this.authentications.default.applyToRequest(localVarRequestOptions)
    );
    let interceptorPromise = authenticationPromise;
    for (const interceptor of this.interceptors) {
      interceptorPromise = interceptorPromise.then(() =>
        interceptor(localVarRequestOptions)
      );
    }
    return interceptorPromise.then(() => {
      if (Object.keys(localVarFormParams).length) {
        if (localVarUseFormData) {
          localVarRequestOptions.formData = localVarFormParams;
        } else {
          localVarRequestOptions.form = localVarFormParams;
        }
      }
      return new Promise((resolve, reject) => {
        localVarRequest(localVarRequestOptions, (error, response, body) => {
          if (error) {
            reject(error);
          } else {
            body = models_1.ObjectSerializer.deserialize(body, "object");
            if (
              response.statusCode &&
              response.statusCode >= 200 &&
              response.statusCode <= 299
            ) {
              resolve({ response: response, body: body });
            } else {
              reject(new apis_1.HttpError(response, body, response.statusCode));
            }
          }
        });
      });
    });
  }
}
exports.MockServerApi = MockServerApi;
//# sourceMappingURL=mockServerApi.js.map
